"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.convertNode = undefined;

var _VariableNode = require("./VariableNode");

var _VariableNode2 = _interopRequireDefault(_VariableNode);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var varRgx = /^[@$]/;

exports.default = function (val, defaultValue) {
    if (val === undefined) return val;
    if (!('' + val).startsWith("@")) {
        return "\"" + val + "\"";
    }
    val = val.replace(varRgx, '');
    var parts = ["props[\"" + val + "\"]", "(props.theme || {})[\"" + val + "\"]", defaultValue];
    return "[" + parts.filter(function (v) {
        return !!v;
    }).join(",") + "].filter(v => v !== void 0)[0]";
};

var convertNode = exports.convertNode = function convertNode(v) {
    var _ref = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
        cssFragment = _ref.cssFragment;

    if (!v) return undefined;
    var value = v.toCSS ? v.toCSS({ cssFragment: cssFragment }) : v.toString();
    if (v instanceof _VariableNode2.default) {
        return value;
    }
    // Deals with "strings"
    if (value.startsWith('`')) {
        return value;
    }
    value = value.replace(/"/g, '\\"');
    return "\"" + value + "\"";
};